﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// RSA 헬퍼
        /// </summary>
        private RSAHelper rsaHelper = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
            this.processButton.Click += processButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.rsaHelper = new RSAHelper();

            this.privateKeyTextBox.Text = this.rsaHelper.PrivateKey;
            this.publicKeyTextBox.Text  = this.rsaHelper.PublicKey;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 암복호화 버튼 클릭시 처리하기 - processButton_Click(sender, e)

        /// <summary>
        /// 암복호화 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void processButton_Click(object sender, EventArgs e)
        {
            string cipherText = this.rsaHelper.Encrypt(this.plainTextTextBox.Text);

            this.cipherTextTextBox.Text = cipherText;

            string plainText = this.rsaHelper.Decrypt(cipherText);

            this.resultTextTextBox.Text = plainText;
        }

        #endregion
    }
}